<script setup lang="ts">
    import { useMsal } from '@/plugins/msal/useMsal'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { Ref, ref, watch } from 'vue'
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import { InterventionServiceOfferApi } from '@/interventionServiceOffer/entities/interventionServiceOffer/InterventionServiceOfferApi'
    import SFooter from '@/components/layout/SFooter.vue'
    import SInterventionServiceOfferForm from '@/shared/administration/components/interventionServiceOffer/SInterventionServiceOfferForm.vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import { useRouter } from 'vue-router'
    import SExpendableButton from '@/shared/button/components/SExpendableButton.vue'
    import { InterventionServiceOffer } from '@/interventionServiceOffer/entities/interventionServiceOffer/InterventionServiceOffer'
    import { interventionServiceOfferMapper } from '@/interventionServiceOffer/entities/interventionServiceOffer/InterventionServiceOfferMapper'
    import { useBreadcrumb } from '@/shared/routing/composables/breadCrumb'
    import { useUserStore } from '@/shared/user/stores/UserStore'

    const msal = useMsal()
    const userStore = useUserStore(msal)

    const interventionServiceOfferApi = new InterventionServiceOfferApi(msal)
    const interventionServiceOffer: Ref<Partial<InterventionServiceOffer>> =
        ref({})

    const router = useRouter()

    const { getParentRoute } = useBreadcrumb()

    const interventionserviceOfferId = String(
        router.currentRoute.value.params.id
    )

    const isLoading = ref(false)

    watch(
        [() => msal.accounts, () => userStore.isImpersonating],
        () => {
            isLoading.value = true
            interventionServiceOfferApi
                .get(interventionserviceOfferId)
                .then(async (fetchedInterventionServiceOffer) => {
                    interventionServiceOffer.value =
                        fetchedInterventionServiceOffer
                })
                .catch((error) => {
                    emitSnackBar((<Error>error).message, 'error')
                    router.push(getParentRoute())
                })
                .finally(() => (isLoading.value = false))
        },
        { immediate: true }
    )

    async function updateInterventionServiceOffer() {
        try {
            await interventionServiceOfferApi.update(
                interventionserviceOfferId,
                interventionServiceOfferMapper.toEditDto(
                    interventionServiceOffer.value
                )
            )

            emitSnackBar(
                `Offre de service "${interventionServiceOffer.value.title}" modifiée`,
                'primary'
            )
            router.push(getParentRoute())
        } catch (error) {
            emitSnackBar((<Error>error).message, 'error')
            router.push(getParentRoute())
        }
    }

    const displayDeleteDialog = ref(false)

    function deleteInterventionServiceOffer() {
        displayDeleteDialog.value = true
    }

    function confirmDeleteInterventionServiceOffer() {
        interventionServiceOfferApi
            .delete(interventionserviceOfferId)
            .then(() => {
                displayDeleteDialog.value = false
                emitSnackBar(
                    `Offre de service "${interventionServiceOffer.value.title}" supprimée`,
                    'primary'
                )
                router.push(getParentRoute())
            })
    }

    function cancelDeleteInterventionServiceOffer() {
        displayDeleteDialog.value = false
    }
</script>

<template>
    <s-contextual-navbar
        page-title="Modifier une offre de service intervention"
    >
        <template #contextualButtons>
            <s-expendable-button
                label="Dupliquer"
                icon="mdi-content-duplicate"
                data-cy="dupliquer-ods-intervention"
                @click="
                    router.push({
                        name: 'admin/ods-intervention/créer',
                        query: {
                            existingInterventionServiceOfferIdToDuplicate:
                                interventionserviceOfferId,
                        },
                    })
                "
            />
            <s-expendable-button
                label="Supprimer"
                icon="mdi-trash-can-outline"
                data-cy="supprimer-ods-intervention"
                @click="deleteInterventionServiceOffer()"
            />
        </template>
    </s-contextual-navbar>
    <v-main>
        <s-content-container>
            <v-skeleton-loader
                v-if="isLoading"
                type="heading, heading, heading, actions"
            ></v-skeleton-loader>
            <s-intervention-service-offer-form
                v-else
                v-model="interventionServiceOffer"
                :loading="interventionServiceOfferApi.isProcessing.value"
                @submit.prevent="updateInterventionServiceOffer()"
            >
            </s-intervention-service-offer-form>
        </s-content-container>
    </v-main>
    <s-footer />

    <v-dialog v-model="displayDeleteDialog" max-width="600">
        <v-card title="Supprimer l'offre de service ?">
            <v-card-text>
                Cette offre de service sera définitivement supprimée
            </v-card-text>
            <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                    color="on-background"
                    :disabled="interventionServiceOfferApi.isProcessing.value"
                    @click="cancelDeleteInterventionServiceOffer"
                    >Annuler</v-btn
                >
                <v-btn
                    color="error"
                    data-cy="confirm-delete-intervention-service-offer"
                    :loading="interventionServiceOfferApi.isProcessing.value"
                    @click="confirmDeleteInterventionServiceOffer()"
                    >Supprimer</v-btn
                >
            </v-card-actions>
        </v-card>
    </v-dialog>
</template>
